<?php
require_once($_SERVER['DOCUMENT_ROOT'].'/config.php');
require_once($_SERVER['DOCUMENT_ROOT'].'/includes/formulas.php');


$link = mysqli_connect(DBASE_HOST,DBASE_USER,DBASE_PASS,DBASE_NAME);
if (! $link) {
	die('Connect Error (' . mysqli_connect_errno() . ') ' . mysqli_connect_error());
}
if (! mysqli_set_charset($link, "utf8" )) {
	echo "error";
	return 1;
}

$result = mysqli_query($link, "SELECT * FROM inventory_fermentables ORDER BY supplier,name");
$row = mysqli_fetch_array($result);


$fermentabletype = array( 'Grain', 'Sugar', 'Extract', 'Dry extract', 'Adjunct' );
$graintype = array( 'Base', 'Roast', 'Crystal', 'Kilned', 'Sour malt', 'Special', 'No malt' );
$addedtype = array( 'Mash', 'Boil', 'Fermentation', 'Lagering', 'Bottle', 'Kegs' );

/*
 * Create beerxml output
 */
$xw = xmlwriter_open_memory();
xmlwriter_set_indent($xw, 1);
$res = xmlwriter_set_indent_string($xw, ' ');

xmlwriter_start_document($xw, '1.0', 'UTF-8');


xmlwriter_start_element($xw, 'FERMENTABLES');
while ($row = mysqli_fetch_array($result)) {

	xmlwriter_start_element($xw, 'FERMENTABLES');

	xmlwriter_start_element($xw, 'VERSION');
	xmlwriter_text($xw, '1');
	xmlwriter_end_element($xw);

	xmlwriter_start_element($xw, 'NAME');
	xmlwriter_text($xw, $row['name']);
	xmlwriter_end_element($xw);

	xmlwriter_start_element($xw, 'NOTES');
        xmlwriter_text($xw, $row['notes']);
        xmlwriter_end_element($xw);

	xmlwriter_start_element($xw, 'TYPE');
	xmlwriter_text($xw, $fermentabletype[$row['type']]);
	xmlwriter_end_element($xw);

        xmlwriter_start_element($xw, 'YIELD');
        xmlwriter_text($xw, sprintf("%.5f",floatval($row['yield'])));
        xmlwriter_end_element($xw);

        xmlwriter_start_element($xw, 'COLOR');
        xmlwriter_text($xw, sprintf("%.3f",ebc_to_srm(floatval($row['color']))));
        xmlwriter_end_element($xw);

        xmlwriter_start_element($xw, 'ADD_AFTER_BOIL');
        ($row['added'] > 1) ? xmlwriter_text($xw, 'TRUE') : xmlwriter_text($xw, 'FALSE');
        xmlwriter_end_element($xw);

        xmlwriter_start_element($xw, 'ORIGIN');
        xmlwriter_text($xw, $row['origin']);
        xmlwriter_end_element($xw);

        xmlwriter_start_element($xw, 'SUPPLIER');
        xmlwriter_text($xw, $row['supplier']);
        xmlwriter_end_element($xw);

        if (floatval($row['coarse_fine_diff'])) {
                xmlwriter_start_element($xw, 'COARSE_FINE_DIFF');
                xmlwriter_text($xw, sprintf("%.4f",floatval($row['coarse_fine_diff'])));
                xmlwriter_end_element($xw);
        }

        if (floatval($row['moisture'])) {
                xmlwriter_start_element($xw, 'MOISTURE');
                xmlwriter_text($xw, sprintf("%.4f",floatval($row['moisture'])));
                xmlwriter_end_element($xw);
        }

        if (floatval($row['diastatic_power'])) {
                xmlwriter_start_element($xw, 'DIASTATIC_POWER');
                xmlwriter_text($xw, sprintf("%.4f",floatval($row['diastatic_power'])));
                xmlwriter_end_element($xw);
        }

        if (floatval($row['protein'])) {
                xmlwriter_start_element($xw, 'PROTEIN');
                xmlwriter_text($xw, sprintf("%.4f",floatval($row['protein'])));
                xmlwriter_end_element($xw);
        }

        if (floatval($row['max_in_batch'])) {
                xmlwriter_start_element($xw, 'MAX_IN_BATCH');
                xmlwriter_text($xw, sprintf("%.3f",floatval($row['max_in_batch'])));
                xmlwriter_end_element($xw);
        }

        xmlwriter_start_element($xw, 'RECOMMEND_MASH');
        ($row['recommend_mash']) ? xmlwriter_text($xw, 'TRUE') : xmlwriter_text($xw, 'FALSE');
        xmlwriter_end_element($xw);

	xmlwriter_start_element($xw, 'DISPLAY_COLOR');
        xmlwriter_text($xw, sprintf("%.0f EBC",floatval($row['color'])));
        xmlwriter_end_element($xw);

        xmlwriter_start_element($xw, 'GRAINTYPE');
        xmlwriter_text($xw, $graintype[$row['graintype']]);
        xmlwriter_end_element($xw);

        xmlwriter_start_element($xw, 'ADDED');
        xmlwriter_text($xw, $addedtype[$row['added']]);
        xmlwriter_end_element($xw);

	if (floatval($row['di_ph'])) {
                xmlwriter_start_element($xw, 'DI_pH');
                xmlwriter_text($xw, sprintf("%.5f",floatval($row['di_ph'])));
                xmlwriter_end_element($xw);
        }

	if (floatval($row['acid_to_ph_57'])) {
                xmlwriter_start_element($xw, 'ACID_TO_pH_5.7');
                xmlwriter_text($xw, sprintf("%.5f",floatval($row['acid_to_ph_57'])));
                xmlwriter_end_element($xw);
        }

	xmlwriter_end_element($xw);	// FERMENTABLE
}
xmlwriter_end_element($xw);	// FERMENTABLES

$beerxml = xmlwriter_output_memory($xw);

Header('Content-type: text/xml');
header('Content-Disposition: attachment; filename="fermentables.xml"');
header('Content-Transfer-Encoding: binary');
header('Expires: 0');
header('Pragma: no-cache');
header('Content-Length: '.strlen($beerxml));
exit($beerxml);
